﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Syncfusion.Mvc.DocIO.Web;
using System.Drawing;
using System.IO;
using System.Data;
using Syncfusion.XlsIO;

namespace GenerateWord.Controllers
{
    public class HomeController : Controller
    {
        string dataPath;
        #region Generate Word
        public ActionResult Index(string Group1)
        {
            if (Group1 == null)
                return View();

            dataPath = Server.MapPath(@"App_Data//").ToString();
            //Create excel engine
            ExcelEngine engine = new ExcelEngine();
            IApplication application = engine.Excel;
            application.DefaultVersion = ExcelVersion.Excel2010;
            //OPen the excel document
            IWorkbook book = application.Workbooks.Open(Path.Combine(dataPath, "ExcelData.xlsx"), ExcelOpenType.Automatic);

            IWorksheet sheet = book.Worksheets[0];
            sheet.EnableSheetCalculations();
            //Export the document as DataTable
            DataTable datatable = sheet.ExportDataTable(sheet.UsedRange, ExcelExportDataTableOptions.ComputedFormulaValues);
            //Open the template Word document
            WordDocument wordDocument = new WordDocument(Path.Combine(dataPath, "WordTemplate.docx"));
            wordDocument.Replace("#placeholder", ReplaceData(datatable), false, false);
            #region saveOption
            if (Group1 == "Word97To2003")
            {
                //Save as .doc Word 97-2003 format
                return wordDocument.ExportAsActionResult("Sample.doc", FormatType.Doc, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            //Save as .docx Word 2007 format
            else if (Group1 == "Word2007")
            {
                return wordDocument.ExportAsActionResult("Sample.docx", FormatType.Word2007, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            //Save as .docx Word 2010 format
            else if (Group1 == "Word2010")
            {
                return wordDocument.ExportAsActionResult("Sample.docx", FormatType.Word2010, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            //Save as .docx Word 2013 format
            else if (Group1 == "Word2013")
            {
                return wordDocument.ExportAsActionResult("Sample.docx", FormatType.Word2013, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            #endregion saveOption

            return View();
        }
        #endregion Getting Started
        private WordDocument ReplaceData(DataTable datatable)
        {
            //Creates new Word document
            WordDocument document = new WordDocument();
            //Adds new setion
            IWSection section = document.AddSection();
            //Adds new table
            IWTable table = section.AddTable();
            //Adds new row to the table
            WTableRow row = table.AddRow();

            //Iterates through data table rows
            foreach (DataRow datarow in datatable.Rows)
            {
                //Adds new row to the table
                row = table.AddRow(true, false);
                foreach (object datacolumn in datarow.ItemArray)
                {
                    //Adds new cell
                    WTableCell cell = row.AddCell();
                    cell.Width = 150;
                    //Adds contents from the data table to the table cell
                    cell.AddParagraph().AppendText(datacolumn.ToString());
                    if (datatable.Rows[datatable.Rows.Count - 1] == datarow)
                    {
                        cell.CellFormat.BackColor = Color.Green;
                    }
                }

            }
            return document;
        }
    }
}
